From c3ed3a67aa07a9b6473924095276caa71c3416ad Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 26 2020 01:02:10 +0000
Subject: [PATCH 387/2232] Remove redundant type parameter of VectorElement


---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 1b3aab3..510fcca 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -655,7 +655,7 @@ fn expand_vector(namespace: &Namespace, ty: &Type) -> TokenStream {
     let link_push_back = format!("{}push_back", prefix);
 
     quote! {
-        unsafe impl ::cxx::private::VectorElement<#inner> for #inner {
+        unsafe impl ::cxx::private::VectorElement for #inner {
             unsafe fn __get_unchecked(v: &::cxx::CxxVector<#inner>, pos: usize) -> &#inner {
                 extern "C" {
                     #[link_name = #link_get_unchecked]
@@ -696,7 +696,7 @@ pub fn expand_vector_builtin(ident: Ident) -> TokenStream {
     let link_push_back = format!("{}push_back", prefix);
 
     quote! {
-        unsafe impl VectorElement<#inner> for #inner {
+        unsafe impl VectorElement for #inner {
             unsafe fn __get_unchecked(v: &CxxVector<#inner>, pos: usize) -> &#inner {
                 extern "C" {
                     #[link_name = #link_get_unchecked]
diff --git a/src/cxx_vector.rs b/src/cxx_vector.rs
index bf9f5fa..5c7c46c 100644
--- a/src/cxx_vector.rs
+++ b/src/cxx_vector.rs
@@ -13,7 +13,7 @@ pub struct CxxVector<T> {
     _private: [T; 0],
 }
 
-impl<T: VectorElement<T>> CxxVector<T> {
+impl<T: VectorElement> CxxVector<T> {
     /// Returns the length of the vector in bytes.
     pub fn len(&self) -> usize {
         T::__vector_length(self)
@@ -46,7 +46,7 @@ pub struct VectorIntoIterator<'a, T> {
     index: usize,
 }
 
-impl<'a, T: VectorElement<T>> IntoIterator for &'a CxxVector<T> {
+impl<'a, T: VectorElement> IntoIterator for &'a CxxVector<T> {
     type Item = &'a T;
     type IntoIter = VectorIntoIterator<'a, T>;
 
@@ -55,7 +55,7 @@ impl<'a, T: VectorElement<T>> IntoIterator for &'a CxxVector<T> {
     }
 }
 
-impl<'a, T: VectorElement<T>> Iterator for VectorIntoIterator<'a, T> {
+impl<'a, T: VectorElement> Iterator for VectorIntoIterator<'a, T> {
     type Item = &'a T;
 
     fn next(&mut self) -> Option<Self::Item> {
@@ -67,10 +67,10 @@ impl<'a, T: VectorElement<T>> Iterator for VectorIntoIterator<'a, T> {
 // Methods are private; not intended to be implemented outside of cxxbridge
 // codebase.
 #[doc(hidden)]
-pub unsafe trait VectorElement<T> {
-    unsafe fn __get_unchecked(v: &CxxVector<T>, pos: usize) -> &T;
-    fn __vector_length(v: &CxxVector<T>) -> usize;
-    fn __push_back(v: &CxxVector<T>, item: &T);
+pub unsafe trait VectorElement: Sized {
+    unsafe fn __get_unchecked(v: &CxxVector<Self>, pos: usize) -> &Self;
+    fn __vector_length(v: &CxxVector<Self>) -> usize;
+    fn __push_back(v: &CxxVector<Self>, item: &Self);
 }
 
 cxxbridge_macro::vector_builtin!(u8);

